<script setup lang="ts">
    import { computed, ref, watchEffect } from 'vue'
    import { Equipement } from '@/interventionServiceOffer/entities/equipement/Equipement'
    import { DemandeIntervention } from '@/interventionServiceOffer/entities/demandeIntervention/DemandeIntervention'
    import SMapPicker from '@/shared/map/components/SMapPicker.vue'
    import SDateRangeField from '@/shared/formField/components/SDateRangeField.vue'
    import { HiddenFields, requiredInject } from '@/shared/helpers/types'
    import { interventionServiceOfferInjectionKey } from '@/interventionServiceOffer/constants'

    const interventionServiceOffer = requiredInject(
        interventionServiceOfferInjectionKey
    )

    interface Props {
        availableEquipements?: Equipement[]
        isLoadingAvailableEquipements?: boolean
        hiddenFields?: { [Property in keyof DemandeIntervention]?: true }
    }

    function isDisplayed(fields: keyof DemandeIntervention) {
        return (
            hiddenFieldsAvecGestionDesDatesSurchargéesDepuisOds.value?.[
                fields
            ] !== true
        )
    }
    const demandeIntervention = defineModel<Partial<DemandeIntervention>>({
        required: true,
    })

    const props = withDefaults(defineProps<Props>(), {
        availableEquipements: () => [],
        isLoadingAvailableEquipements: false,
        hiddenFields: () => ({}),
    })

    const hiddenFieldsAvecGestionDesDatesSurchargéesDepuisOds = computed<
        HiddenFields<DemandeIntervention>
    >(() => {
        return {
            ...props.hiddenFields,
            dateDeDebutSouhaitee:
                props.hiddenFields?.dateDeDebutSouhaitee ||
                !interventionServiceOffer.value?.data
                    ?.gestionDatesSouhaiteesPourDemandeInterventionActif ||
                undefined,
            dateDeFinSouhaitee:
                props.hiddenFields?.dateDeFinSouhaitee ||
                !interventionServiceOffer.value?.data
                    ?.gestionDatesSouhaiteesPourDemandeInterventionActif ||
                undefined,
        }
    })

    watchEffect(() => {
        if (props.availableEquipements.length === 1) {
            demandeIntervention.value.relatedEquipement =
                props.availableEquipements[0]
        }
    })

    const titleMaxLenght = 60
    const descriptionMaxLenght = 500

    // variables d'état
    const formFieldsAreValid = ref<boolean>(false)

    defineExpose({ formFieldsAreValid })

    const rules = {
        hasTitle: (input: string | undefined) => {
            return !!input || 'Le titre est obligatoire.'
        },
        hasShortEnoughDescriptionIfFilled: (input: string | undefined) => {
            return (
                input === undefined ||
                input.length <= descriptionMaxLenght ||
                'Votre description ne doit pas dépasser plus de ' +
                    descriptionMaxLenght +
                    ' caractères'
            )
        },
        hasRelatedEquipement: (input: string | undefined | null) => {
            return (
                !!input ||
                "Vous devez préciser le lieu de la demande d'intervention"
            )
        },
        hasShortEnoughtTitle: (input: string | undefined) =>
            input === undefined ||
            input.length <= titleMaxLenght ||
            'Votre titre ne doit pas dépasser plus de  ' +
                titleMaxLenght +
                ' caractères',
    }
</script>

<template>
    <v-form ref="form" v-model="formFieldsAreValid">
        <v-row>
            <v-col v-if="isDisplayed('title')" cols="12">
                <v-text-field
                    v-model="demandeIntervention.title"
                    data-cy="titre-de-la-demande"
                    :label="'Titre*'"
                    counter
                    class="mt-5"
                    :maxlength="titleMaxLenght"
                    :rules="[rules.hasTitle, rules.hasShortEnoughtTitle]"
                ></v-text-field>
            </v-col>
            <v-col
                v-if="
                    isDisplayed('relatedEquipement') ||
                    isDisplayed('coordonnees')
                "
                cols="12"
            >
                <v-autocomplete
                    v-if="isDisplayed('relatedEquipement')"
                    v-model="demandeIntervention.relatedEquipement"
                    auto-select-first
                    return-object
                    :loading="isLoadingAvailableEquipements"
                    :disabled="availableEquipements.length < 2"
                    :hint="
                        availableEquipements.length === 0
                            ? 'Il n\'y a pas d\'équipement permettant la création de demandes'
                            : undefined
                    "
                    persistent-hint
                    class="mb-3"
                    data-cy="select-equipement"
                    label="Localisation*"
                    :items="availableEquipements"
                    item-title="label"
                    item-value="id"
                    variant="outlined"
                    placeholder="Localisation"
                    :rules="[rules.hasRelatedEquipement]"
                ></v-autocomplete>
                <s-map-picker
                    v-if="isDisplayed('coordonnees')"
                    ref="mapPickerRef"
                    v-model="demandeIntervention.coordonnees"
                    height="400px"
                    :prevent-drag="true"
                />
            </v-col>
            <v-col v-if="isDisplayed('description')" cols="12">
                <v-textarea
                    v-model="demandeIntervention.description"
                    class="ma-0"
                    data-cy="description"
                    label="Description"
                    variant="outlined"
                    :counter="descriptionMaxLenght"
                    :rules="[rules.hasShortEnoughDescriptionIfFilled]"
                    auto-grow
                ></v-textarea>
            </v-col>
            <s-date-range-field
                v-if="
                    isDisplayed('dateDeDebutSouhaitee') &&
                    isDisplayed('dateDeFinSouhaitee')
                "
                v-model:date-de-debut="demandeIntervention.dateDeDebutSouhaitee"
                v-model:date-de-fin="demandeIntervention.dateDeFinSouhaitee"
                label-date-de-debut="Date de début souhaitée"
                label-date-de-fin="Date de fin souhaitée"
            />
            <v-col cols="12">
                <v-alert
                    v-if="
                        availableEquipements.length === 0 &&
                        isDisplayed('relatedEquipement')
                    "
                    type="warning"
                    data-cy="message-pas-d-equipement-dispo-pour-creation-di"
                    class="mb-4"
                >
                    Aucun équipement ne permet la création de demande dans ce
                    contexte.
                </v-alert>
            </v-col>
        </v-row>
    </v-form>
</template>
